<?php

class ControladorGeneral{

	/*=============================================
	REGISTRO DE SUCURSAL
	=============================================*/

	static public function ctrCrearGeneral(){
		if(isset($_POST["nuevoNombre"])){
			if(preg_match('/[a-zA-Z0-9 ]/', $_POST["nuevoNombre"])){
			   	/*=============================================
				VALIDAR IMAGEN
				=============================================*/
				$ruta = "vistas/dist/img/logo/Logo.jpeg";
				if(isset($_FILES["nuevaFoto"]["tmp_name"])){
					list($ancho, $alto) = getimagesize($_FILES["nuevaFoto"]["tmp_name"]);
					$nuevoAncho = 500;
					$nuevoAlto = 500;
					/*=============================================
					CREAMOS EL DIRECTORIO DONDE VAMOS A GUARDAR LA FOTO DEL LOGO
					=============================================*/
					$directorio = "vistas/dist/img/logo/".$_POST["nuevoRepresentante"];
					mkdir($directorio, 0755);
					/*=============================================
					DE ACUERDO AL TIPO DE IMAGEN APLICAMOS LAS FUNCIONES POR DEFECTO DE PHP
					=============================================*/
					if($_FILES["nuevaFoto"]["type"] == "image/jpeg"){
						/*=============================================
						GUARDAMOS LA IMAGEN EN EL DIRECTORIO
						============================================*/
						$aleatorio = mt_rand(100,999);
						$ruta = $directorio."/".$aleatorio.".jpg";
						$origen = imagecreatefromjpeg($_FILES["nuevaFoto"]["tmp_name"]);						
						$destino = imagecreatetruecolor($nuevoAncho, $nuevoAlto);
						imagecopyresized($destino, $origen, 0, 0, 0, 0, $nuevoAncho, $nuevoAlto, $ancho, $alto);
						imagejpeg($destino, $ruta);
					}
					if($_FILES["nuevaFoto"]["type"] == "image/png"){
						/*=============================================
						GUARDAMOS LA IMAGEN EN EL DIRECTORIO
						=============================================*/
						$aleatorio = mt_rand(100,999);
						$ruta = $directorio."/".$aleatorio.".png";
						$origen = imagecreatefrompng($_FILES["nuevaFoto"]["tmp_name"]);						
						$destino = imagecreatetruecolor($nuevoAncho, $nuevoAlto);
						imagecopyresized($destino, $origen, 0, 0, 0, 0, $nuevoAncho, $nuevoAlto, $ancho, $alto);
						imagepng($destino, $ruta);
					}
				}
				$tabla = "sucursal";
				$datos = array("razon_social" => $_POST["nuevoNombre"],
					           "tipo_documento" => $_POST["nuevoTipoDocumento"],
					           "num_documento" => $_POST["nuevoDocumento"],
							   "direccion" => $_POST["nuevoDireccion"],
							   "telefono" => $_POST["nuevoTelefono1"],
							   "email" => $_POST["nuevoCorreo"],
							   "representate" => $_POST["nuevoRepresentante"],
					           "logo"=>$ruta);
				$respuesta = ModeloSucursal::mdlIngresarSucursal($tabla, $datos);
				if($respuesta == "ok"){
					echo '<script>
					swal({
						type: "success",
						title: "¡Datos Generales ha sido guardado correctamente!",
						showConfirmButton: true,
						confirmButtonText: "Cerrar"
					}).then(function(result){
						if(result.value){
							window.location = "general";
						}
					});
					</script>';
				}	
			}else{
				echo '<script>
					swal({
						type: "error",
						title: "¡Datos Generales no puede ir vacío o llevar caracteres especiales!",
						showConfirmButton: true,
						confirmButtonText: "Cerrar"
					}).then(function(result){
						if(result.value){
							window.location = "general";
						}
					});
				</script>';
			}
		}
	}

	/*=============================================
	MOSTRAR SUCURSAL
	=============================================*/

	static public function ctrMostrarSucursal($item, $valor){

		$tabla = "sucursal";

		$respuesta = ModeloSucursal::MdlMostrarSucursal($tabla, $item, $valor);

		return $respuesta;
	}

	/*=============================================
	EDITAR USUARIO
	=============================================*/

	static public function ctrEditarSucursal(){
		if(isset($_POST["editarNombre"])){
			if(preg_match('/[a-zA-Z0-9 ]/', $_POST["editarNombre"])){
				$ruta = $_POST["fotoActual"];
				if(isset($_FILES["editarFoto"]["tmp_name"]) && !empty($_FILES["editarFoto"]["tmp_name"])){
					list($ancho, $alto) = getimagesize($_FILES["editarFoto"]["tmp_name"]);
					$nuevoAncho = 500;
					$nuevoAlto = 500;
					$directorio = "vistas/dist/img/logo/".$_POST["editarRepresentante"];
					/*=============================================
					PRIMERO PREGUNTAMOS SI EXISTE OTRA IMAGEN EN LA BD
					=============================================*/
					if(!empty($_POST["fotoActual"])){
						unlink($_POST["fotoActual"]);
					}else{
						mkdir($directorio, 0755);
					}	
					/*=============================================
					DE ACUERDO AL TIPO DE IMAGEN APLICAMOS LAS FUNCIONES POR DEFECTO DE PHP
					=============================================*/
					if($_FILES["editarFoto"]["type"] == "image/jpeg"){
						/*=============================================
						GUARDAMOS LA IMAGEN EN EL DIRECTORIO
						=============================================*/
						$aleatorio = mt_rand(100,999);
						$ruta = $directorio."/".$aleatorio.".jpg";
						$origen = imagecreatefromjpeg($_FILES["editarFoto"]["tmp_name"]);						
						$destino = imagecreatetruecolor($nuevoAncho, $nuevoAlto);
						imagecopyresized($destino, $origen, 0, 0, 0, 0, $nuevoAncho, $nuevoAlto, $ancho, $alto);
						imagejpeg($destino, $ruta);
					}
					if($_FILES["editarFoto"]["type"] == "image/png"){
						/*=============================================
						GUARDAMOS LA IMAGEN EN EL DIRECTORIO
						=============================================*/
						$aleatorio = mt_rand(100,999);
						$ruta = $directorio."/".$aleatorio.".png";
						$origen = imagecreatefrompng($_FILES["editarFoto"]["tmp_name"]);						
						$destino = imagecreatetruecolor($nuevoAncho, $nuevoAlto);
						imagecopyresized($destino, $origen, 0, 0, 0, 0, $nuevoAncho, $nuevoAlto, $ancho, $alto);
						imagepng($destino, $ruta);
					}
				}
				$tabla = "sucursal";
				$datos = array("razon_social" => $_POST["editarNombre"],
					           "tipo_documento" => $_POST["editarTipoDocumento"],
					           "num_documento" => $_POST["editarDocumento"],
							   "direccion" => $_POST["editarDireccion"],
							   "telefono" => $_POST["editarTelefono1"],
							   "email" => $_POST["editarCorreo"],
							   "representate" => $_POST["editarRepresentante"],
							   "id" => $_POST["idSucursal"],
					           "logo"=>$ruta);
				$respuesta = ModeloSucursal::mdlEditarSucursal($tabla, $datos);
				if($respuesta == "ok"){
					echo'<script>
					swal({
						  type: "success",
						  title: "Los Datos Generales ha sido editado correctamente",
						  showConfirmButton: true,
						  confirmButtonText: "Cerrar"
						  }).then(function(result){
									if (result.value) {

									window.location = "general";
									
									}
							})

					</script>';
				}
			}else{
				echo'<script>
					swal({
						  type: "error",
						  title: "¡El nombre no puede ir vacío o llevar caracteres especiales!",
						  showConfirmButton: true,
						  confirmButtonText: "Cerrar"
						  }).then(function(result){
							if (result.value) {

							window.location = "general";

							}
						})

			  	</script>';

			}

		}

	}

	/*=============================================
	BORRAR USUARIO
	=============================================*/

	static public function ctrBorrarSucursal(){
		if(isset($_GET["idSucursal"])){
			$tabla ="sucursal";
			$datos = $_GET["idSucursal"];
			if($_GET["fotoSucursal"] != "" && $_GET["fotoSucursal"] != "vistas/dist/img/logo/LOGO_SM_AZUL.jpg"){
				unlink($_GET["fotoSucursal"]);
				rmdir('vistas/dist/img/logo/'.$_GET["representante"]);
			}
			$respuesta = ModeloSucursal::mdlBorrarSucursal($tabla, $datos);
			if($respuesta == "ok"){
				echo'<script>
				swal({
					  type: "success",
					  title: "Sucursal ha sido borrado correctamente",
					  showConfirmButton: true,
					  confirmButtonText: "Cerrar"
					  }).then(function(result){
								if (result.value) {
								window.location = "general";
								}
							})
				</script>';
			}		
		}
	}
}